/****************************************************************************

Projekt:            UrlObfuscator
Package:            de.mvcsys.misc
Class:              UrlObfuscator

Dateiname:          UrlObfuscator.java

Aufgabe:            URL-Verschleierung

Programmierer:      Marcus von Cube

Aenderungen:

Datum     Name      Vers.  Bemerkung
-----------------------------------------------------------------------------
08.12.03  MvC       1.0    erstellt

****************************************************************************/

package de.mvcsys.misc;

import java.awt.*;
import java.awt.event.*;

/**
 *  URL-Verschleierung
 */
public class UrlObfuscator extends Frame
{
    protected TextField url = new TextField();
    protected TextField encoded = new TextField() {
        public Dimension getPreferredSize() {
            Dimension d = super.getPreferredSize();
            d.width = 400;
            return d;
        }
    };
    protected Button clearButton = new Button();
    protected Button generateButton = new Button();
    protected Button exitButton = new Button();
    protected Label Heading = new Label();
    protected Label label1 = new Label();
    protected Label label3 = new Label();
    protected Label status = new Label();
    protected Panel panel1 = new Panel();
    protected Panel panel2 = new Panel();
    protected Panel panel3 = new Panel();
    protected Panel panel4 = new Panel();
    protected Panel panel5 = new Panel();
    protected BorderLayout borderLayout1 = new BorderLayout();
    protected BorderLayout borderLayout2 = new BorderLayout( 2, 2 );
    protected GridBagLayout gridBagLayout1 = new GridBagLayout();
    protected GridBagLayout gridBagLayout2 = new GridBagLayout();

    protected String PROMPT_CLEAR = "Please enter the URL part after the colon!";
    protected String PROMPT_OK = "You can now copy & paste the result";

    public UrlObfuscator()
    {
        super();
        enableEvents( AWTEvent.WINDOW_EVENT_MASK );
        try {
            jbInit();
            pack();
        }
        catch( Exception e ) {
            e.printStackTrace();
        }
    }

    void jbInit() throws Exception
    {
        this.setBackground(new Color(234, 234, 234));
        this.setTitle("URL Obfuscator");
        this.setLayout(borderLayout2);
        Heading.setAlignment(1);
        Heading.setBackground(new Color(202, 202, 213));
        Heading.setFont(new java.awt.Font("SansSerif", 1, 18));
        Heading.setForeground(new Color(0, 51, 153));
        Heading.setText("URL Obfuscator");
        panel1.setLayout(borderLayout1);
        generateButton.setActionCommand("Generate");
        generateButton.setLabel("Generate");
        generateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                generateButton_actionPerformed(e);
            }
        });
        clearButton.setActionCommand("Clear");
        clearButton.setLabel("Clear");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                clearButton_actionPerformed(e);
            }
        });
        panel2.setLayout(gridBagLayout1);
        panel4.setLayout(gridBagLayout2);
        label1.setText("URL:");
        label3.setText("Result:");
        encoded.setEditable(false);
        this.setVisible(true);
        status.setAlignment(1);
        status.setBackground(new Color(202, 202, 213));
        status.setText( PROMPT_CLEAR );
        exitButton.setActionCommand("Exit");
        exitButton.setLabel("Exit");
        exitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancel();
            }
        });
        panel5.setBackground(new Color(234, 234, 234));
        panel2.setBackground(new Color(234, 234, 234));
        panel3.setBackground(new Color(234, 234, 234));
        panel4.setBackground(new Color(234, 234, 234));
        this.add( Heading, BorderLayout.NORTH );
        this.add( panel1, BorderLayout.CENTER );
        panel1.add( panel2, BorderLayout.EAST );
        panel2.add( generateButton,         new GridBagConstraints(0, 1, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 5, 2), 2, 2) );
        panel2.add( clearButton,          new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 0, 2), 2, 2) );
        panel2.add(panel3,      new GridBagConstraints(0, 3, 2, 1, 0.0, 2.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
        panel2.add(exitButton,      new GridBagConstraints(0, 4, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 0, 2), 0, 0));
        panel1.add(panel4, BorderLayout.CENTER);
        panel4.add(label1,     new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 5, 0, 5), 0, 0));
        panel4.add(url,     new GridBagConstraints(1, 0, 1, 1, 2.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 0, 5), 0, 0));
        panel4.add(label3,     new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 5, 0, 5), 0, 0));
        panel4.add(encoded,     new GridBagConstraints(1, 1, 1, 1, 2.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 0, 5), 0, 0));
        this.add(status, BorderLayout.SOUTH);
        panel4.add(panel5,   new GridBagConstraints(0, 3, 2, 1, 0.0, 2.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
        url.requestFocus();
    }

    protected void processWindowEvent(WindowEvent e)
    {
        if ( e.getID() == WindowEvent.WINDOW_CLOSING ) {
            cancel();
        }
        super.processWindowEvent( e );
    }

    void cancel()
    {
        dispose();
        System.exit( 0 );
    }

    public static void main( String args[] )
    {
        new UrlObfuscator();
    }

    protected void setStatus( String text ) {
        status.setText( text );
    }

    void generateButton_actionPerformed(ActionEvent e)
    {
        String urlText = url.getText().trim();

        encoded.setText( encode( urlText ) );
        encoded.requestFocus();
        encoded.selectAll();
        setStatus( PROMPT_OK );
    }

    void clearButton_actionPerformed(ActionEvent e)
    {
        url.setText( "" );
        encoded.setText( "" );
        setStatus( PROMPT_CLEAR );
        url.requestFocus();
    }

    static String encode( String in )
    {
        int l = in.length();
        StringBuffer result = new StringBuffer( 3 * l );

        for ( int i = 0; i < l ; ++i ) {
            int c = (int) in.charAt( i ) % 0xFF;
            result.append( '%' );
            result.append( Integer.toHexString( c ) );
        }
        return result.toString().toUpperCase();
    }

}
